/*******************************************************************
 *
 *	File:		App.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __APP_H
#define __APP_H

#include <coecntrl.h>
#include <coeccntx.h>
#include <coemain.h>

// MR
//#include <eikappui.h>
//#include <eikapp.h>
#include <aknappui.h>
#include <aknapp.h>
#include <eikdoc.h>

#include "Engine.h"
#include "EDoom.hrh"

const TUid KUidEDoomApp = { 0x10009BB5 };

class CWsBitmap;
class CGameRunningDialog;

class CEDoomDocument : public CEikDocument
{
public:
	~CEDoomDocument();
	CEDoomDocument(CEikApplication& aApp);
	void ConstructL();

private: // from CEikDocument
	CEikAppUi* CreateAppUiL();
};


class CEDoomAppView : public CCoeControl, public MCoeControlBrushContext
{
public:
	~CEDoomAppView();
	void ConstructL(const TRect& aRect);
private:
	void Draw(const TRect& /*aRect*/) const;

	CWsBitmap*	iBgImage;
	TPoint		iImagePosition;
};


//class CEDoomAppUi : public CEikAppUi, public MGameWatcher
class CEDoomAppUi : public CAknAppUi, public MGameWatcher
{
public:
	CEDoomAppUi(){}
	void ConstructL();
	~CEDoomAppUi();

public:			// implements MGameWatcher
	void NotifyGameFinished();


protected: // from CEikAppUi
	void HandleCommandL(TInt aCommand);
	TKeyResponse HandleKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType);

protected:		// new stuf
	void DisplayAboutDialogL();
	void DisplayControlsHelpDialogL();
	void DisplayControlsWadFilesDialogL();
	void DisplayControlsEditCmdLineDialogL();
	void SaveCommandLine(void);
	void LoadCommandLine(void);

	void StopGame();
	void RunGameL();
	CGameRunningDialog*		iGameRunningDialog;
	CGameRunner*			iGameRunner;

private:
	CEDoomAppView* iAppView;
	TBuf<512> iCmdLine;
};



//class CEDoomApplication : public CEikApplication
class CEDoomApplication : public CAknApplication
	{
private: // from CApaApplication
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
	};

#endif
