/*******************************************************************
 *
 *	File:		Engine.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ENGINE_H
#define __ENGINE_H

#include <e32base.h>

class MGameWatcher
{
public:
	virtual void NotifyGameFinished() = 0;
};


class CGameRunner : public CActive
{
public:
	static CGameRunner* NewL(MGameWatcher& aGameWatcher);
	~CGameRunner();

	void RunGameL();
	void TerminateGame(TBool aNotifyObserver = ETrue);
	void ResumeGame();

protected:
	CGameRunner(MGameWatcher& aGameWatcher);
	void ConstructL();

	virtual void RunL();
	virtual void DoCancel();

	void DoRunGameL();
	void ShutdownGame();
	
	MGameWatcher&		iGameWatcher;
	RThread				iThread;
};



#endif