// Emacs style mode select   -*- C++ -*-
//-----------------------------------------------------------------------------
//
// $Id: byteptr.h,v 1.4 2000/04/16 18:38:06 bpereira Exp $
//
// Copyright (C) 1998-2000 by DooM Legacy Team.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// $Log: byteptr.h,v $
// Revision 1.4  2000/04/16 18:38:06  bpereira
// no message
//
//
// DESCRIPTION:
//    Macro to read/write from/to a char*, used for packet cration and such...
//
//-----------------------------------------------------------------------------

#ifdef __SYMBIAN32__

#define WRITEBYTE(p,b)      *((byte   *)p)++ = b
#define WRITECHAR(p,b)      *((char   *)p)++ = b
#define WRITESHORT(p,b)     {short temp=b;memcpy(p, &temp, sizeof(short));((char*)p)+=sizeof(short);}
#define WRITEUSHORT(p,b)    {USHORT temp=b;memcpy(p, &temp, sizeof(USHORT));((char*)p)+=sizeof(USHORT);}
#define WRITELONG(p,b)      {long temp=b;memcpy(p, &temp, sizeof(long));((char*)p)+=sizeof(long);}
#define WRITEULONG(p,b)     {ULONG temp=b;memcpy(p, &temp, sizeof(ULONG));((char*)p)+=sizeof(ULONG);}
#define WRITEFIXED(p,b)     {fixed_t temp=b;memcpy(p, &temp, sizeof(fixed_t));((char*)p)+=sizeof(fixed_t);}
#define WRITEANGLE(p,b)     {angle_t temp=b;memcpy(p, &temp, sizeof(angle_t));((char*)p)+=sizeof(angle_t);}
#define WRITESTRING(p,b)    { int tmp_i=0; do { WRITECHAR(p,b[tmp_i]); } while(b[tmp_i++]); }
#define WRITESTRINGN(p,b,n) { int tmp_i=0; do { WRITECHAR(p,b[tmp_i]); if(!b[tmp_i]) break;tmp_i++; } while(tmp_i<n); }
#define WRITEMEM(p,s,n)     memcpy(p, s, n);p+=n

#define READBYTE(p)         *((byte   *)p)++
#define READCHAR(p)         *((char   *)p)++
#define READSHORT(p)        DoReadShort(((short*)p)++)
#define READUSHORT(p)       DoReadUshort(((unsigned short*)p)++)
#define READLONG(p)         DoReadlong(((long*)p)++)
#define READULONG(p)        DoReadUlong(((unsigned long*)p)++)
#define READMEM(p,s,n)      memcpy(s, p, n);p+=n
//#define READSHORT(p)        ( (READBYTE(p)) | (READBYTE(p) << 8) )
//#define READUSHORT(p)       ( (READBYTE(p)) | (READBYTE(p) << 8) )
//#define READLONG(p)         ( (READBYTE(p)) | (READBYTE(p) << 8) | (READBYTE(p) << 16) | (READBYTE(p)) <<24)
//#define READULONG(p)        ( (READBYTE(p)) | (READBYTE(p) << 8) | (READBYTE(p) << 16) | (READBYTE(p)) <<24)
/*
 * both defined as functions in p_saveg.c
 */
#define READFIXED(p)        DoReadFixed(((fixed_t*)p)++)
#define READANGLE(p)        DoReadAngle(((angle_t*)p)++)
#define READSTRING(p,s)     { int tmp_i=0; do { s[tmp_i]=READBYTE(p);  } while(s[tmp_i++]); }
#define SKIPSTRING(p)       while(READBYTE(p))

static void writelong(void * ptr, int val)
{
	memcpy(ptr, &val, sizeof(long));
}

static short readshort(void * ptr)
{
	return *(short *)ptr;
}

#else

#define WRITEBYTE(p,b)      *((byte   *)p)++ = b
#define WRITECHAR(p,b)      *((char   *)p)++ = b
#define WRITESHORT(p,b)     *((short  *)p)++ = b
#define WRITEUSHORT(p,b)    *((USHORT *)p)++ = b
#define WRITELONG(p,b)      *((long   *)p)++ = b
#define WRITEULONG(p,b)     *((ULONG  *)p)++ = b
#define WRITEFIXED(p,b)     *((fixed_t*)p)++ = b
#define WRITEANGLE(p,b)     *((angle_t*)p)++ = b
#define WRITESTRING(p,b)    { int tmp_i=0; do { WRITECHAR(p,b[tmp_i]); } while(b[tmp_i++]); }
#define WRITESTRINGN(p,b,n) { int tmp_i=0; do { WRITECHAR(p,b[tmp_i]); if(!b[tmp_i]) break;tmp_i++; } while(tmp_i<n); }

#define READBYTE(p)         *((byte   *)p)++
#define READCHAR(p)         *((char   *)p)++
#define READSHORT(p)        *((short  *)p)++
#define READUSHORT(p)       *((USHORT *)p)++
#define READLONG(p)         *((long   *)p)++
#define READULONG(p)        *((ULONG  *)p)++
#define READFIXED(p)        *((fixed_t*)p)++
#define READANGLE(p)        *((angle_t*)p)++
#define READSTRING(p,s)     { int tmp_i=0; do { s[tmp_i]=READBYTE(p);  } while(s[tmp_i++]); }
#define SKIPSTRING(p)       while(READBYTE(p))

#endif

/*static void writelong(void * ptr, int val)
{
  char * cp = ptr;
  cp[0] = val ;  val >>= 8;
  cp[1] = val ;  val >>= 8;
  cp[2] = val ;  val >>= 8;
  cp[3] = val ;
}*/
